//
//	Class definition for Control class
//

#ifndef LDW_HINT_CONTROL_H
#define LDW_HINT_CONTROL_H

#include "ldwTypes.h"
#include "ldwControl.h"

class ldwBackground;
class ldwHintControlImpl;
class ldwFont;
class ldwScene;

class ldwHintControl : public ldwControl
{
public:

	static void SetBackground(ldwBackground *background);
	static void SetBackgroundColors(ldwColor borderColor,ldwColor interiorColor);
	static void SetTextProperties(ldwColor textColor,ldwFont *font);
	static void SetWait(ldwUINT32 waitMS);
	static void EnableHints(bool enable);
	static void SetOffsets(int x,int y);

	ldwHintControl(int id,ldwRect &bounds,ldwScene *parent,const char *hintText,ldwColor textColor = cLdwBlack,ldwFont *font = 0,ldwBackground *background = 0);
	ldwHintControl(int id,ldwRect &bounds,ldwScene *parent,ldwWCHAR *hintText,ldwColor textColor = cLdwBlack,ldwFont *font = 0,ldwBackground *background = 0);

	ldwHintControl(int id);

	virtual ~ldwHintControl();
	
	virtual void SetPos(int x,int y);

	virtual int GetWidth();
	virtual int GetHeight();

	virtual void SetActive(bool active);
	virtual void Draw() {}	
	
	void DrawHint();

	void SetHint(const char *hintText,ldwColor textColor = cLdwBlack,ldwFont *font = 0,ldwBackground *background = 0);
	void SetHint(const ldwWCHAR *text,ldwColor textColor = cLdwBlack,ldwFont *font = 0,ldwBackground *background = 0);

	void SetHintWait(ldwUINT32 waitMS);
	void EnableHint(bool enable);

	void OnHintArea(ldwPoint location);			
	void OffHintArea();

protected:

	virtual void GetBounds(ldwRect &bounds);

	ldwHintControlImpl *mHint;
};										

#endif
