//
//	Class definition for the Game State
//
//	- uses ldwGameState as base class
//

#ifndef THE_COLLECTING_CLASS_H
#define THE_COLLECTING_CLASS_H

//#include "ldwGameState.h"
//#include "WorldMap.h"
//#include "isola.h"
#include "theGameState.h"
//#include "ldwGameWindow.h"
#include "ldwTypes.h"
//#include "theSoundFxManager.h"

//class theGameState;
//class ldwGameWindow;
//class theVillagerClass;
//class theFloatingAnims;
//class theSoundManager;
class theContentMap;
class theGraphicsManager;
class theFloatingAnims;
class theSoundManager;
class theDealerSay;

//#define maxNumBirds 9
//#define defaultBirdAnimSpeed		2
//#define numButterflySets			5
#define cCollectableHotspotLeftOffset		10
#define cCollectableHotspotTopOffset		20
#define cCollectableHotspotRightOffset		50
#define cCollectableHotspotBottomOffset		40

#define collectableDuration					75
#define shroomDuration						75
#define chanceOfRareCollectable				2 //beta 4: 4...beta 1 3
#define chanceOfUncommonCollectable			14 //beta 4: 16...beta 1 15
#define chanceOfRareShroom					10

#define commonCollectableTechValue			100; //beta 1 250
#define uncommonCollectableTechValue		250; //beta 1 400
#define rareCollectableTechValue			1500; //beta 1 5000 //beta 2 2500

#define chanceOfCollectable					4 //beta 1 6
#define chanceOfShroom						50

#define widthOfCollectable					40
#define heightOfCollectable					25

#define numButterflies						12
#define numBeetles							12
#define numDragonflies						12
#define numSpiders							12

#define chanceOfMutingRepeats				40
#define globalChanceOfCollectibleSpawn		6
#define chanceOfSpecialSpawn				75 //this represents a full garden of special plants

#define chanceOfRareSpawn					8
#define chanceOfUncommonSpawn				25

#define commonInsectValue					5
#define uncommonInsectValue					20
#define rareInsectValue						40

typedef enum
{
	eButterfly1 = 0,
	eButterfly2,
	eButterfly3,
	eButterfly4,
	eButterfly5,
	eButterfly6,
	eButterfly7,
	eButterfly8,
	eButterfly9,
	eButterfly10,
	eButterfly11,
	eButterfly12,
	eBeetle1,
	eBeetle2,
	eBeetle3,
	eBeetle4,
	eBeetle5,
	eBeetle6,
	eBeetle7,
	eBeetle8,
	eBeetle9,
	eBeetle10,
	eBeetle11,
	eBeetle12,
	eDragonfly1,
	eDragonfly2,
	eDragonfly3,
	eDragonfly4,
	eDragonfly5,
	eDragonfly6,
	eDragonfly7,
	eDragonfly8,
	eDragonfly9,
	eDragonfly10,
	eDragonfly11,
	eDragonfly12,
	eSpider1,
	eSpider2,
	eSpider3,
	eSpider4,
	eSpider5,
	eSpider6,
	eSpider7,
	eSpider8,
	eSpider9,
	eSpider10,
	eSpider11,
	eSpider12,


}	CollectableEnum;

typedef enum{

	eWalking,
	eLanding,
	eLeaving,
	eFlying,
	eSunning,
	eHiding,
	eDropping
	

} CollectableBehaviorEnum;

typedef enum{

	eCollectablesUnderPlants,
	eCollectablesOverPlants

} CollectableDrawOrderEnum;

typedef enum{

	eDirectionRight,
	eDirectionLeft

} DirectionEnum;


typedef struct
{
	bool exists;
	ldwPoint position;
	//ldwRect hotspot;
	ldwPoint target;
	ldwPoint landingTarget;
	ldwPoint velocity;
	ldwUINT32 timer;
	CollectableEnum whichRare;
	int animFrame;
	int animIdx;
	DirectionEnum direction;
	int stepsCounter;
	CollectableBehaviorEnum behaviorType;
	bool capturedState;
	int scale;

} CollectableType;


typedef enum{

	eCollectable,
	eShroom
} CollectableClassEnum;

class theCollectingClass 
{
public:

	static theCollectingClass * Get();
	static void Destroy();
	
	~theCollectingClass();

	CollectableType collectable; 
//	CollectableType shroom;
	
	void Init();
	bool LDWPointInRect(int x,int y,int left,int top,int width,int height);
	void SpawnRandomCollectable();
	//void SpawnTutorialCollectable(CollectableClassEnum itemClass);
	void PickGroundBeetleStartCoords();

	void RemoveCollectable();
	void CheckCollectableExpiration();
	bool CheckForClickOnCollectable(ldwPoint location);
	bool CheckForMouseoverOnCollectable(ldwPoint location);
	void InitiateStartledBehavior();
		
	void PickButterflyStartLandingCoords();

	void AcquireWanderingTarget();
	void UpdateButterflies();
	void UpdateDragonflies();
	void UpdateBeetles();
	void UpdateSpiders();

	void AcquireLandingTarget(int x, int y);

	bool CheckCollectableExists();
	int CheckCollectableRarity();
	void DrawCollectable(CollectableDrawOrderEnum drawOrder);
	void UpdateCollectable();

	void RefreshCollectable();

	void SpawnButterfly(int whichButterfly);
	void SpawnBeetle(int whichBeetle);
	void SpawnDragonfly(int whichDragonfly);
	void SpawnSpider(int whichDragonfly);

	bool SpawnSpecialInsect();

	bool SpawnSpecialBaseTypeInsect(int row, int column);
	bool SpawnSpecialFlowerTypeInsect(int row, int column);

	bool ChanceOfCollectableSpawn();
	CollectableEnum GetLiveCollectable();

	void SellCollectible();

	int CountCapturedCollectibles();


protected:



	//protected constructor.  called internally from Get()
	theCollectingClass();
	static theCollectingClass *mInstance;

	theGameState *gs;
	theContentMap *contentMap;
	theGraphicsManager *gm;
	theFloatingAnims *fm;
	theSoundManager *sm;
	theDealerSay *ds;

	ldwPoint	homingPos;
};

#endif
