//
//		Definition of the main game class
//
#ifndef THE_HELP_SCENE_H
#define THE_HELP_SCENE_H

#include "ldwScene.h"
#include "ldwGameWindow.h"
#include "ldwImage.h"
#include "theStringManager.h"

class ldwButton;
class ldwSoundTrack;
class theGameState;
class ldwTextControl;
class theSoundManager;
class theGraphicsManager;

class theHelpScene : public ldwScene
{
public:

	theHelpScene();
	~theHelpScene();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void DrawScene();
	void UpdateScene();

private:

	ldwGameWindow   *gameWindow;
	theGameState    *gs;
	theSoundManager *soundMgr;
	theStringManager *stringMgr;
	theGraphicsManager *gm;

	int  pageNum;
	int  creditPageNumSave;

	bool leftBtnHidden;
	bool rightBtnHidden;

	ldwRect displayRect;

	//ldwImage *BG;
	ldwImage *help1Cover;
	ldwImage *help2Cover;	
	ldwImage *help3Cover;	
	ldwImage *help4Cover;
	ldwImage *help5Cover;
	ldwImage *help6Cover;
	ldwImage *help7Cover;
	ldwTextControl *sceneLabel;

	const int doneButtonId;
	const int creditsButtonId;
	const int rightNavBtnId;
	const int leftNavBtnId;

	ldwButton *doneButton;
	ldwButton *leftNavBtn;
	ldwButton *rightNavBtn;
	ldwButton *creditsButton;
};
#endif