/******************************************************************************\
**
**     COMPANY:	LDW
**
**      MODULE:	theHomingClass
**
** DESCRIPTION:	"Homes" an object towards a target position
**
**      AUTHOR:	Adrian Francis
**
\******************************************************************************/

#ifndef THE_HOMING_CLASS_H
#define THE_HOMING_CLASS_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/

/******************************************************************************\
** TYPE DEFINITIONS
\******************************************************************************/
typedef void (* LPHOMINGCALLBACK)(int iCallbackData);

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class theHomingClass
{
private:

	// class data
	bool				m_bIsHoming;

	int					m_iRef;

	int &				m_iCurrentX;
	int &				m_iCurrentY;

	int					m_iTargetRectX;
	int					m_iTargetRectY;
	int					m_iTargetRectWidth;
	int					m_iTargetRectHeight;

	int					m_iVelocity;

	LPHOMINGCALLBACK	m_lpCallback;
	int					m_iCallbackData;

	//class methods
	//setup
	public:		theHomingClass(int &iCurrentX, int &iCurrentY);

	//process
	public:		void Home(int iRef, int iTargetRectX, int iTargetRectY, int iTargetRectWidth, int iTargetRectHeight, int iVelocity, LPHOMINGCALLBACK lpCallback, int iCallbackData);
	public:		void Update();
	public:		void Stop();

	//access
	public:		bool IsHoming(void);
	public:		int Ref(void);
};

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/