//
//		Definition of the into2 game class
//
#ifndef THE_INTRO2_SCENE_H
#define THE_INTRO2_SCENE_H


#include "ldwScene.h"
#include "ldwGameWindow.h"
#include "ldwImage.h"

class ldwButton;
class theSoundManager;
class theGameState;
class theGraphicsManager;
class ldwTextControl;
class theStringManager;

class theIntro2Scene : public ldwScene
{
public:

	theIntro2Scene();
	~theIntro2Scene();
	
	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void DrawScene();
	void UpdateScene();

private:

	ldwGameWindow      *gameWindow;
	theGameState       *gs;
	theGraphicsManager *gm;
	theSoundManager    *soundMgr;
	theStringManager   *stringMgr;

	bool visitedAtLeastOnce;

	int   fadeInCount;
	bool  beginFadeOut;
	int   fadeOutCount;
	bool  fadeInComplete;
	bool  fadeOutComplete;
	float fadeTrans;

	ldwRect fadeInOutRect;
	
	ldwTextControl *line1;
	ldwTextControl *line2;
	ldwTextControl *line3;
	ldwTextControl *line4;
	ldwTextControl *line5;
	ldwTextControl *line6;

	const int yesButtonId;
	const int noButtonId;

	ldwButton      *yesButton;
	ldwButton		*noButton;
};
#endif