//
//		Definition of the main game class
//
#ifndef THE_MENU_SCENE_H
#define THE_MENU_SCENE_H


#include "ldwScene.h"

#include "ldwImage.h"

class theGameState;
class theGraphicsManager;
class theSoundManager;
class theStringManager;
class theFloatingAnims;

class ldwButton;
class ldwGameWindow;
class ldwTextControl;

#define widthOfMenuButtons 120
#define heightOfMenuButtons 30
#define lavaOpacityIncrement 0.008f


#define menuPlayButtonX	151
#define menuPlayButtonY	190
#define menuStartOverButtonX	151
#define menuStartOverButtonY	240
#define menuOptionsButtonX		151
#define menuOptionsButtonY		290
#define menuHelpButtonX			151
#define menuHelpButtonY			340
#define menuExitButtonX			151
#define menuExitButtonY			390
#define menuChangePlayerButtonX	550
#define menuChangePlayerButtonY	50

typedef enum {
	eMenuButtonNULL,
	eMenuButtonPlay,
	eMenuButtonStartOver,
	eMenuButtonOptions,
	eMenuButtonHelp,
	eMenuButtonExit,
	eMenuButtonChangePlayer
}	MenuButtonEnum;

class theMenuScene : public ldwScene
{
public:

	theMenuScene();
	~theMenuScene();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void Activate(bool active);

	void DrawScene();
	void UpdateScene();

	void UpdateShowPlayer();

private:

	theGraphicsManager *gm;

	ldwGameWindow    *gameWindow;
	theGameState     *gs;
	theSoundManager  *soundMgr;
	theStringManager *stringMgr;
	theFloatingAnims *fa;
	
	ldwPoint mousePos;
	ldwPoint oldMousePos;
	bool mouseIsDown;

	ldwRect playButtonArea;
	ldwRect startOverButtonArea;
	ldwRect optionsButtonArea;
	ldwRect helpButtonArea;
	ldwRect exitButtonArea;
	ldwRect changePlayerButtonArea;

	int inWhichButton;

	const int playButtonId;
	const int changePlayerButtonId;
	const int startOverButtonId;
	const int optionsButtonId;
	const int helpButtonId;
	const int exitButtonId;
	const int cPlayerNameLblId;

	ldwButton		*playButton;
	ldwButton		*startOverButton;
	ldwButton		*optionsButton;
	ldwButton		*helpButton;
	ldwButton      *exitButton;
	ldwButton		*changePlayerButton;

	ldwTextControl *versionLabel;
	ldwTextControl *currentPlayer;	
	ldwTextControl *copyrightLabel;

};
#endif