//
//		Definition of the sell scene class
//
#ifndef THE_SHOPPER_CLASS_H
#define THE_SHOPPER_CLASS_H

#include "theGameState.h"
#include "ldwGameWindow.h"
#include "theContentMap.h"
#include "theFloatingAnims.h"
#include "thePlantClass.h"
//#include "ldwTypes.h"

#define maxNumPlans 60
#define maxNumNurseryItems 16
#define numHeadTypes 17
#define numBodyTypes 10

#define agesUntilElderly 1000
#define greyHairOnsetOffset 100

#define numFramesWalkingAnim 8
#define cNorth		 1
#define cSouth		 2
#define intNortheast 0
#define intSoutheast 1
#define intSouthwest 2
#define intNorthwest 3

#define mapWestBoundryDef 1
#define mapNorthBoundryDef 1
#define mapEastBoundryDef 850
#define mapSouthBoundryDef 599

#define MaxNumShoppers 128
#define MaxNumberShoppers 128

#define bodyUp									0
#define bodyBent								1
#define bodySitting								2
#define bodyWorking								3
#define bodyHidden								4
#define bodyStill								5
#define bodyStoopNW								6
#define bodyStoopNE								7
#define bodyStoopSE								8
#define bodyStoopSW								9
#define bodyJumping								10
#define bodyCrouchNW							11
#define bodyCrouchNE							12
#define bodyCrouchSE							13
#define bodyCrouchSW							14
#define bodyStoopArmsNW							15
#define bodyStoopArmsNE							16
#define bodyStoopArmsSE							17
#define bodyStoopArmsSW							18
#define bodySitNW								19
#define bodySitNE								20
#define bodySitSE								21
#define bodySitSW								22


#define reaquisitionFreq						10

#define targetTolerance							2

#define peepCrawlSpeed							40
#define peepWalkSpeed							100
//#define peepRunSpeed							150
#define peepRunSpeed							200
#define peepSprintSpeed							300

#define numBendingFrames						4

#define importantPlan							1
#define pushPlan								2

#define genderNULL								0
#define genderMale								1
#define genderFemale							2

#define northObstructionDef						1
#define eastObstructionDef						2
#define southObstructionDef						3
#define westObstructionDef						4

#define  giveUpPoint							25

#define widthOfPeeps							21
#define heightOfPeeps							42
#define cHeadOffsetStd							6
#define cHeadOffsetWrk							6
#define cHeadOffsetBnd							2
#define cHeadOffsetNWStoopX						-4
#define cHeadOffsetNWStoopY						0
#define cHeadOffsetNEStoopX						0
#define cHeadOffsetNEStoopY						2
#define cHeadOffsetSEStoopX						2
#define cHeadOffsetSEStoopY						1
#define cHeadOffsetSWStoopX						-3
#define cHeadOffsetSWStoopY						1

#define cBodyOffsetNWStoopX						-3
#define cBodyOffsetNWStoopY						-2
#define cBodyOffsetNEStoopX						1
#define cBodyOffsetNEStoopY						1
#define cBodyOffsetSEStoopX						2
#define cBodyOffsetSEStoopY						2
#define cBodyOffsetSWStoopX						0
#define cBodyOffsetSWStoopY						3

#define cBodyOffsetNWStoopArmsX						-2
#define cBodyOffsetNWStoopArmsY						-3
#define cBodyOffsetNEStoopArmsX						-2
#define cBodyOffsetNEStoopArmsY						-3
#define cBodyOffsetSEStoopArmsX						-2
#define cBodyOffsetSEStoopArmsY						-3
#define cBodyOffsetSWStoopArmsX						-2
#define cBodyOffsetSWStoopArmsY						-3

#define cHeadOffsetNWStoopArmsX						-4
#define cHeadOffsetNWStoopArmsY						0
#define cHeadOffsetNEStoopArmsX						-4
#define cHeadOffsetNEStoopArmsY						0
#define cHeadOffsetSEStoopArmsX						-4
#define cHeadOffsetSEStoopArmsY						0
#define cHeadOffsetSWStoopArmsX						-4
#define cHeadOffsetSWStoopArmsY						0

#define cSitYBodyOffset								2
#define cSitYHeadOffset								-6
#define cSitXBodyOffset							3
#define cSitXHeadOffset							0
#define maxNameLength							25

#define cCuriosityThreshold						4
#define cBoredThreshold							4
#define cBoredHysterLvl							2
#define cCuriousHysterLvl						2

#define cMinStoopDelay							700
#define cMinStoopPointDelay						150

#define maxNumGoldenPlants						6

#define cStoneTurtleEnterPoints					1
#define cStoneTurtleSpawnPoints					1
#define cSundialEnterPoints						1
#define cSundialSpawnPoints						1
#define cWeatherVaneEnterPoints					1
#define cWeatherVaneSpawnPoints					1
#define cLanternEnterPoints						1
#define cLanternSpawnPoints						1
#define cOwlEnterPoints							1
#define cOwlSpawnPoints							1
#define cBuddhaEnterPoints						1
#define cBuddhaSpawnPoints						1
#define cBirdhouseEnterPoints					1
#define cBirdhouseSpawnPoints					1
#define cCherubEnterPoints						1
#define cCherubSpawnPoints						1
#define cBenchEnterPoints						1
#define cBenchSpawnPoints						1
#define cFountainEnterPoints					5
#define cFountainSpawnPoints					4
#define cSignEnterPoints						2
#define cSignSpawnPoints						4
#define cFenceEnterPoints						2
#define cFenceSpawnPoints						4
#define cGateEnterPoints						2
#define cGateSpawnPoints						4
#define cRegisterEnterPoints					1
#define cRegisterSpawnPoints					1
#define cPaintEnterPoints						2
#define cPaintSpawnPoints						4

#define cPlantOfJoyEnterPoints 4
#define cPlantOfJoySpawnPoints 4
#define cPlantOfLifeEnterPoints 2
#define cPlantOfLifeSpawnPoints 2
#define cPlantOfWealthEnterPoints 2
#define cPlantOfWealthSpawnPoints 2
#define cPlantOfKnowledgeEnterPoints 2
#define cPlantOfKnowledgeSpawnPoints 2
#define cPlantOfIsolaEnterPoints 2
#define cPlantOfIsolaSpawnPoints 2
#define cPlantOfFragranceEnterPoints 2
#define cPlantOfFragranceSpawnPoints 2
#define cBugCollectionSpawnPoints 4
#define cPlantEnterPoints 2
#define cPlantSpawnPoints 2

#define cMinimumEnterPercent 20
#define cMaxEnterPercent 80

#define cMinimumSpawnedPeeps 8
#define cMaxSpawnedPeeps 55
typedef enum
{
	doNothing,
	wandering,
	waiting,
	going,
	swimming,
	dancing,
	learn,
	working,
	climbing,
	diving,
	jumping,
	bending,
	embrace,
	hiding,
	following,
	carry,
	dontcarry,
	advancestate,
	facedirection,
	shakinghead,
	healingEnum,
	soundon,
	soundoff,
	takingcorpse,
	casting,
	dealersay,
	followGradient,
	endingState,
	terminatorBehavior

} BehaviorType;

typedef enum
{
	originState,
	eApprchEntr,
	eLeaveEntr,
	eBrowseWest,
	eBrowseEast,
	eBrowseCenter,
	eBrowseSouth,
	eBrowseCR,
	eGenericBrowse,
	eBuyAPlant,
	eBrowsePlant,
	eBrowseOrnament

} NurseryStateEnum;


typedef enum
{
	ePlantIdeaRuined,
	ePlantIdeaCheap,
	ePlantIdeaExpensive,
	ePlantIdeaInfested,
	ePlantIdeaWeak,
	ePlantIdeaPruned,
	ePlantIdeaNoFlowers,
	ePlantIdeaBrown,
	ePlantIdeaNice,
	ePlantIdeaNullCondition

} PlantConditionIdeaEnum;

typedef enum
{
	eNullItem = 0,
	ePlantClN3,
	ePlantClWNW,
	ePlantClWSW,
	ePlantClS1,
	ePlantClS2,
	ePlantClS3,
	ePlantClS4,
	ePlantClS5,
	ePlantClS6,
	ePlantClESE,
	ePlantClESW,
	ePlantClENW,
	ePlantClENE,
	ePlantClN1,
	ePlantClN2,
	eEndNormalPlants,
	ePlantGNW,
	ePlantGW,
	ePlantGSW,
	ePlantGSE,
	ePlantGE,
	ePlantGNE,
	eEndGoldenPlants,
	eItemStoneTurtle,
	eItemSundial,
	eItemWeatherVane,
	eItemBugZapper,
	eItemOwl,
	eItemBuddha,
	eItemBirdHouse,
	eItemCherub,
	eItemBench,
	eItemFountain,
	eItemSign,
	eItemFence,
	eItemGate,
	eItemCashReg,
	eItemPaint,
	eItemLast


} NurseryItemsEnum;

typedef enum
{
	//eIdeaNULL = 0,
	eIdeaRuined = 0,
	eIdeaLikePlants,
	eIdeaDontLikePlants,
	eIdeaPlantsCheap,
	eIdeaPlantsExpensive,
	eIdeaPlantSick,
	eIdeaTooFewPlants,
	eIdeaLovePlants,
	eIdeaNicePrune,
	eIdeaInfested,
	eIdeaWheresTheTurtle,
	eIdeaNiceTurtle,
	eIdeaWheresTheSundial,
	eIdeaNiceSundial,
	eIdeaWheresTheVane,
	eIdeaNiceVane,
	eIdeaWheresTheLantern,
	eIdeaNiceLantern,
	eIdeaWheresTheOwl,
	eIdeaNiceOwl,
	eIdeaWheresTheBuddha,
	eIdeaNiceBuddha,
	eIdeaWheresTheBirdhouse,
	eIdeaNiceBirdhouse,
	eIdeaWheresTheCherub,
	eIdeaNiceCherub,
	eIdeaWheresTheBench,
	eIdeaNiceBench,
	eIdeaTooFewOrnaments, //will be eIdeaWheresTheFountain / eIdeaNiceFountain wkh 8-2-07
	eIdeaNiceOrnaments,
	eIdeaFlower1,
	eIdeaFlower2,
	eIdeaFlower3,
	eIdeaFlower4,
	eIdeaFlower5,
	eIdeaPlant1,
	eIdeaPlant2,
	eIdeaPlant3,
	eIdeaPlant4,
	eIdeaPlant5,
	eIdeaFish,
	eIdeaCoffee,
	eIdeaBaby,
	eIdeaPrius,
	eIdeaHome,
	eIdeaEndIdeaList,
	eIdeaNULL

} IdeaEnum;

class theDealerSay;
class theGraphicsManager;
class theGameState;
class thePlantManager;
class theStringManager;


typedef struct
{

	unsigned long secondsAccumilated;
	unsigned long lastTimeChecked;

	int health;
	int age;
	int agesChecked;
	int gender;
	int disease;
	int pregnancyStartTime;
	int twins;
	int headType;
	int bodyType;
	int fName;
	int lName;
	
	bool isTotem;
	int totemX;
	int totemY;
	//char firstName[maxNameLength];

	//parental data
	//char fatherName[maxNameLength];
	//char motherName[maxNameLength];
	int fatherHeadType;
	int fatherBodyType;
	int motherHeadType;
	int motherBodyType;

	//husband data
	//char husbandName[maxNameLength];
	int husbandBodyType;
	int husbandHeadType;

	int fatherSkillType; 
	int fatherSkillValue;
	int fatherLName;


	//int likes[maxNumLikes];
	//int dislikes[maxNumLikes];

	int predisposition; //predisposed to do what last told if relevant

} BioType;



typedef struct
{
	BehaviorType doWhat;
	int x;
	int y;
	ldwUINT32 behaviorTimer;	//was "ldwUINT32" whatever that is .. put it back wkh 3-27- 07
	int behaviorCounter; //for counting number of frames of something, or misc use
	int misc; //(often speed)
} PlanType;


typedef struct
{
	BehaviorType doWhat;
	PlanType plans[10];
	ldwUINT32 behaviorTimer;	//was "ldwUINT32" whatever that is .. put it back wkh 3-27- 07
	int behaviorCounter; //for counting number of frames of something, or misc use
	ldwUINT32 behaviorTimer2;
	int misc; //(often speed)
	int tired;
	int curious;
	int buy;
	int bored;
	bool havePlan;
	ldwUINT32 wanderTimer;
} MotivationType;


typedef struct 
{
	int X;
	int Y;
	int xVel;
	int yVel;
	int xMom;
	int yMom;
	int frame_idx;
	//int frame;
	int animFrame;
	int displacementFrame;
	int displacementDirection;
	int animDirection; //1 or -1 depending if bending down or up, for example

	bool exists;
	bool focus;
	bool inHand;

	//bool soundOn;
	//int whichSound;

	int direction; //uses 'int<direction' defs
	int headDirection;
	int bodyPosition;
	int carrying;
	int giveUpCounter;
	
	PlanType plan[maxNumPlans];

	char behaviorLabel[40];
	float opacity;
	IdeaEnum idea;
	bool fadeIn;
	bool fadeOut;
	bool thoughtBubble;
	BioType bio;
	//SkillsType skills;
	MotivationType motivations;
	ldwUINT32 learnTimer;
	ldwUINT32 thinkTimer;
	ldwUINT32 tBubTimer;
	NurseryStateEnum currentState;
	ContentMapGradientType navGradient;
}
VillagerType;



class theShopperClass 
{
public:

	static theShopperClass * Get();
	static void Destroy();

	void DrawVillagers();	

	VillagerType           shopper[MaxNumberShoppers + 1];

	VillagerType			theClerk;
	int drawOrder[MaxNumberShoppers + 1];
	void DecideWhatToDo(int whichShopper);
	void StartWaiting(int whichShopper);
	void StartWandering(int whichVillager);
	void StartGoing(int whichVillager);
	void ChanceOfHeadturn(int whichShopper, int percent);
	void ProcessWaiting(int whichShopper);
	void ProcessWandering(int whichShopper);
	void NormVel(int whichShopper, int speed);
	void AcquireTarget(int whichShopper);
	void IterateAllVillagers();
	void NextPlan(int whichShopper);
	void StartNothing(int whichShopper);
	void StartNewBehavior(int whichShopper);
	void ReorderVillagerDrawOrder();
	void ProcessGoing(int whichShopper);
	void ProcessFollowGradient(int whichShopper);
	void ForgetPlans(int whichShopper);
	void InitShoppers();
	void ProcessBending(int whichShopper);
	void ProcessWorking(int whichShopper);
	void StartBending(int whichShopper);
	void StartWorking(int whichShopper);
	void PlanPathAround(int whichShopper, int direction);
	void CreatePlan(int whichVillager, BehaviorType doWhat, int x, int y, long timer, int importance, int misc);
	void BevMacExploreGarden1(int whichShopper);
	void BevMacExploreGarden2(int whichShopper);
	int SpawnSpecificPeep(int lName, int whichSkill, int howMuchSkill, int whatGender, int whatAge, char * fatherName, char * motherName, int fatherBodyType, int fatherHeadType, int motherBodyType, int motherHeadType, int forceX, int forceY, bool oldClothes);
	int SpawnRandomPeep();
	void ShopperLeaving(int whichShopper);
	void BevMacLeaveGarden(int whichShopper);
	void ShopperWrap(int whichShopper, int dir);
	void DrawBubble(int whichShopper);
	int CheckForShopperClick(ldwPoint click);
	void UpdateMotivation(int whichShopper);

	void StartJumping(int whichShopper);
	void ProcessJumping(int whichShopper);
	void BevMacExploreGardenCenter(int whichShopper);
	void BevMacExploreGardenCW(int whichShopper);
	void BevMacExploreGardenSoCent(int whichShopper);
	void SubBevMacSpin(int whichShopper, int delay);
	void BevMacExploreGardenSE(int whichShopper);
	void SubBevMacFiddleNW(int whichShopper, int delay);
	void SubBevMacFiddleNE(int whichShopper, int delay);
	void SubBevMacFiddleSE(int whichShopper, int delay);
	void SubBevMacFiddleSW(int whichShopper, int delay);
	void SubBevMacFiddle2NW(int whichShopper, int delay);
	void SubBevMacFiddle2NE(int whichShopper, int delay);
	void SubBevMacFiddleW(int whichShopper);
	void SubBevMacFiddleN(int whichShopper);
	void SubBevMacFiddleE(int whichShopper);
	void SubBevMacFiddleS(int whichShopper);

	void BevMacBrowseCenterCluster(int whichShopper);

	NurseryStateEnum EnterNewState(int whichShopper);
	void BevMacLeaveEntr(int whichShopper);
	void BevMacApprchEntr(int whichShopper);
	void BevMacBrowseWestClusterNW(int whichShopper);
	void BevMacBrowseWestClusterNE(int whichShopper);
	void BevMacBrowseWestClusterSE(int whichShopper);
	void BevMacBrowseWestClusterSW(int whichShopper);
	void BevMacBrowseEastClusterNW(int whichShopper);
	void BevMacBrowseEastClusterNE(int whichShopper);
	void BevMacBrowseEastClusterSW(int whichShopper);
	void BevMacBrowseEastClusterSE(int whichShopper);
	void BevMacBrowseSouthCluster1(int whichShopper);
	void BevMacBrowseSouthCluster2(int whichShopper);
	void BevMacBrowseSouthCluster3(int whichShopper);
	void BevMacBrowseSouthCluster4(int whichShopper);
	void BevMacBrowseSouthCluster5(int whichShopper);
	void BevMacBrowseSouthCluster6(int whichShopper);
	void BevMacBrowseCenterCluster10(int whichShopper);
	void BevMacBrowseCenterCluster2(int whichShopper);
	void BevMacBrowseCenterCluster3(int whichShopper);
	void BevMacBrowseCenterCluster5(int whichShopper);
	void BevMacBrowseCenterCluster7(int whichShopper);
	void BevMacBrowseCenterCluster9(int whichShopper);
	void BevMacBrowseCashRegister(int whichShopper);
	int CollectValidPlanters();
	int CollectOranaments();
	void ChoosePlanterBox(int whichShopper, int numChoices);
	void ClearPlanterList();
	void ClearOrnamentList();
	void ChooseDestination(int whichShopper);
	void BevMacEntranceLobby(int whichShopper);
	int NurserySpawnFactor();
	int NurseryEnterFactor();
	int CountActiveShoppers();
	void DecideWhatToThink(int whichShopper);
	void ChooseOrnament(int whichShopper, int numChoices);
	void DecideOnAdditionalActions(int whichShopper);
	void ChooseMiscBehavior(int whichShopper);
	void BevMacMiscPace(int WhichShopper);
	void BevMacMiscSpaz(int WhichShopper);
	void DespawnPeepIfOffscreen(int whichShopper);
	void BevMacBrowseNorthCluster1(int whichShopper);
	void BevMacBrowseNorthCluster2(int whichShopper);
	void BevMacBrowseNorthCluster3(int whichShopper);
	void BevMacMiscPace2(int whichShopper);
	void BevMacMiscSpaz2(int whichShopper);
	void BevMacGotoCashReg(int whichShopper);
	void BevMacPlayInFountain(int whichShopper);
	void ClearActiveShopperList();
	void SubBevMacBuyN3(int whichShopper);
	void SubBevMacBuyWNW(int whichShopper);
	void SubBevMacBuyWSW(int whichShopper);
	void SubBevMacBuyS1(int whichShopper);
	void SubBevMacBuyS2(int whichShopper);
	void SubBevMacBuyS3(int whichShopper);
	void SubBevMacBuyS4(int whichShopper);
	void SubBevMacBuyS5(int whichShopper);
	void SubBevMacBuyS6(int whichShopper);
	void SubBevMacBuyESE(int whichShopper);
	void SubBevMacBuyESW(int whichShopper);
	void SubBevMacBuyENW(int whichShopper);
	void SubBevMacBuyENE(int whichShopper);
	void SubBevMacBuyN1(int whichShopper);
	void SubBevMacBuyN2(int whichShopper);
	void BevMacBrowseGoldenNW(int whichShopper);
	void BevMacBrowseGoldenW(int whichShopper);
	void BevMacBrowseGoldenSW(int whichShopper);
	void BevMacBrowseGoldenSE(int whichShopper);
	void BevMacBrowseGoldenE(int whichShopper);
	void BevMacBrowseGoldenNE(int whichShopper);
	void ClearGPList();
	int	 CollectGoldenPlants();
	void ChooseGoldenPlant(int whichShopper, int numChoices);
	void BevMacBrowseSundial(int whichShopper);
	void BevMacBrowseBench(int whichShopper);
	void BevMacBrowseCherub(int whichShopper);
	void BevMacBrowseGreenhouse(int whichShopper);
	void BevMacBrowseOwl(int whichShopper);
	void BevMacBrowseBuddha(int whichShopper);
	void BevMacBrowseWeatherVane(int whichShopper);
	void BevMacBrowseTurtle(int whichShopper);
	void BevMacBrowseFountain(int whichShopper);
	void BevMacBrowseBirdHouse(int whichShopper);
	void BevMacRunLaps(int whichShopper);
	void DrawClerk();
	void IterateClerk();
	void InitClerk();

	//void ForgetPlans(int whichShopper);
	//void BevMacExploreGardenCW(int whichShopper);
	//void NextPlan(int whichShopper);

	void DrawAllThoughtBubbles();

	int CollectActiveShoppers();
	//void ChanceOfHeadturn(int whichShopper, int percent);

	void FollowGrid();

	int mFollowingGradient;
	NurseryItemsEnum planterList[maxNumNurseryItems];
	NurseryItemsEnum ornamentList[maxNumNurseryItems];
	NurseryItemsEnum GpList[maxNumNurseryItems];
	int activeShopperIndexList[MaxNumShoppers + 1];
	
	int numSpawnedShoppers;
	bool makeSound;
protected:
		static theShopperClass *mInstance;

private:

	theShopperClass();
	~theShopperClass();

	//SpriteType SPRITE[maxNumSprites];
	int SPRITEIDX;
	int SPRITEREORDERCOUNTER;

	ldwUINT32 SELLTIMER;
	ldwUINT32 COMMENTCOUNT;
	ldwUINT32 GARDENADCOUNTER; 

//	bool COLLMATRIX[maxNumCollGrids][maxNumCollGrids];
	
	bool hasDrawn;
	
	int reorderCounter;
	theDealerSay       *ds;
	theGameState       *gs;
	theGraphicsManager *gm;
	thePlantManager    *pm;
	theStringManager   *stringMgr;
	ldwGameWindow	   *gameWindow;
	theContentMap      *contentMap;

	ldwImageGrid	 *male1Sheet;
	ldwImageGrid	 *male1HeadSheet;
	ldwImageGrid	 *male1ActionsSheet;
	ldwImageGrid	 *male1HeadSheetOld;
	ldwImageGrid	 *female1Sheet;
	ldwImageGrid	 *female1HeadSheet;
	ldwImageGrid	 *female1HeadSheetOld;
	ldwImageGrid	 *female1ActionsSheet;

	ldwImage		 *tBubbleL;
	ldwImage		 *tBubbleR;
	ldwImage		 *idea1;
	
	ldwImage		 *idea2;
	ldwImage		*shopperShadow;
	ldwPoint		TopLeft;

	//NurseryItemsEnum ItemList[maxNumNurseryItems];
};
#endif